"
 COPYRIGHT (c) 2006 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libtool' }"

LibraryDefinition subclass:#stx_libtool
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_libtool class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2006 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    Build-Information for creation of the st/x standard library: stx_libtool.
    This library contains developer tools.
"
!

extensionsVersion_CVS
    ^ '$Header: /cvs/stx/stx/libtool/stx_libtool.st,v 1.42 2010-04-23 12:12:45 stefan Exp $'
!

extensionsVersion_SVN
    ^ 'Id:'
! !

!stx_libtool class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
        #'stx:goodies/xml/stx'    "XMLCoder - referenced by Tools::NewSystemBrowser>>selectorMenuFileOutXMLAs "
        #'stx:libsvn'    "SVN::RepositoryManager - referenced by NewLauncher>>updateInfo "
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:goodies/refactoryBrowser/parser'    "RBProgramNodeVisitor - superclass of Tools::BreakpointBrowser::MessageArgumentExtractor "
        #'stx:libbasic'    "Object - superclass of VersionDiffBrowser::ClassChangeSet "
        #'stx:libbasic2'    "List - superclass of AbstractFileBrowser::DirectoryHistory "
        #'stx:libbasic3'    "AbstractSourceCodeManager - referenced by Tools::NewSystemBrowser>>checkAcceptedMethod:inClass: "
        #'stx:libcomp'    "Parser - referenced by Tools::NewSystemBrowser>>checkForEmptyMethodComment:inClass: "
        #'stx:libui'    "VariablePanelSpec - superclass of FileBrowserV2UISpecifications::PanelSpec "
        #'stx:libview'    "TopView - superclass of ChangesBrowser "
        #'stx:libview2'    "Model - superclass of Tools::ClassGeneratorList "
        #'stx:libwidg'    "DialogBox - superclass of AboutBox "
        #'stx:libwidg2'    "HierarchicalList - superclass of SettingsDialog::HierarchicalApplicationList "
        #'stx:libwidg3'    "ClockView - referenced by WorkspaceApplication>>addStopWatch "
    )
! !

!stx_libtool class methodsFor:'description - compilation'!

additionalBaseAddressDefinition_bc_dot_mak
    "this is an optional definition, which (if present) may speed up the dll-loading a little
     on win32 systems."

    ^ '
# see stdHeader_bc for LIBTOOL_BASE
LIB_BASE=$(LIBTOOL_BASE)
'
! !

!stx_libtool class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        AboutBox
        AbstractFileApplicationNoteBookComponent
        AbstractFileBrowser
        AbstractLauncherApplication
        (AbstractRevisionItem autoload)
        AbstractSettingsApplication
        (AbstractVersionDiffBrowserItem autoload)
        (ApplicationBuilder autoload)
        BookmarksEditDialog
        BrowserView
        ChangesBrowser
        (ClassInspectorView autoload)
        (ClassItem autoload)
        (ClassItemRoot autoload)
        (ClassItemRootForRevision autoload)
        (ClassNameItem autoload)
        (ClassRevisionTree autoload)
        (ClassVariablesInspectorView autoload)
        CodeGeneratorTool
        (ColorInspectorView autoload)
        DebugView
        (Diff3TextView autoload)
        DiffListUtility
        DiffTextView
        (EWorldIconLibrary autoload)
        (EventMonitor autoload)
        (ExpandableRevisionItem autoload)
        FileBrowser
        FileBrowserV2PanelView
        (FileBrowserV2SettingsDialog autoload)
        (FileBrowserV2Tests autoload)
        FileBrowserV2UISpecifications
        FileDialog
        (FileDialogV2 autoload)
        FileOperation
        FilenameEditFieldV2
        (HierarchicalClassRevisionList autoload)
        (HierarchicalVersionDiffBrowser autoload)
        InspectorView
        (Launcher autoload)
        (LibraryBuilder autoload)
        MemoryMonitor
        MemoryMonitorView
        (MemoryUsageView autoload)
        MultiViewToolApplication
        (NewChangesBrowser autoload)
        (OldLauncher autoload)
        (ProcessMonitor autoload)
        ProcessMonitorV2
        (ProjectView autoload)
        (RCSConflictEditTextView autoload)
        (SemaphoreMonitor autoload)
        SettingsDialog
        (SmalltalkInspectorView autoload)
        (SourceRevisionItem autoload)
        SystemBrowser
        (SystemStatusMonitor autoload)
        (TerminalApplication autoload)
        #'Tools::BreakpointBrowser'
        #'Tools::CheckinInfoDialog'
        #'Tools::ClassChecker'
        #'Tools::CodeCritics'
        (#'Tools::CompilerWarningToDoListEntry' autoload)
        #'Tools::MethodCategoryCache'
        #'Tools::NavigationState'
        #'Tools::NavigatorModel'
        #'Tools::NewClassWizardDialog'
        #'Tools::SearchDialog'
        #'Tools::SpecialCodeView'
        #'Tools::StringSearchTool'
        (#'Tools::ToDoList' autoload)
        (#'Tools::ToDoListBrowser' autoload)
        (#'Tools::ToDoListEntry' autoload)
        (#'Tools::ToDoNotification' autoload)
        VersionDiffBrowser
        (VersionRevisionItem autoload)
        ViewWithAcceptAndCancelBar
        Win32FileDialog
        #'stx_libtool'
        AbstractDirectoryBrowser
        ChangeSetBrowser
        ContextInspectorView
        DictionaryInspectorView
        DiffCodeView
        FileApplicationNoteBook
        FileBrowserV2
        FileBrowserV2SettingsAppl
        FindFileApplication
        ImageInspectorView
        NewLauncher
        OrderedCollectionInspectorView
        SetInspectorView
        #'Tools::BrowserList'
        #'Tools::NavigatorCanvas'
        #'Tools::NewSystemBrowser'
        #'Tools::OrganizerCanvas'
        #'Tools::StringSearchToolForTextView'
        WorkspaceApplication
        DirectoryContentsBrowser
        DirectoryTreeBrowser
        #'Tools::ClassCategoryList'
        #'Tools::ClassGeneratorList'
        #'Tools::ClassList'
        #'Tools::MethodCategoryList'
        #'Tools::MethodList'
        #'Tools::NamespaceList'
        #'Tools::ProjectList'
        #'Tools::VariableList'
        #'Tools::FullMethodCategoryList'
        #'Tools::HierarchicalClassCategoryList'
        #'Tools::HierarchicalClassList'
        #'Tools::HierarchicalProjectList'
        #'Tools::ImplementingClassList'
        #'Tools::ImplementingMethodList'
        #'Tools::InheritanceClassList'
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
        ByteArray inspectorExtraAttributes
        Character inspectorExtraAttributes
        CharacterArray inspectorExtraAttributes
        Collection inspectorExtraAttributes
        Color inspectorClass
        Color inspectorExtraAttributes
        Dictionary inspectorClass
        ExecutableFunction printStringForBrowserWithSelector:
        Form inspectorClass
        Image inspectorClass
        Integer inspectorExtraAttributes
        Method inspectorExtraAttributes
        Method printStringForBrowserWithSelector:inClass:
        Method selectorPrintStringInBrowserFor:
        Method selectorPrintStringInBrowserFor:class:
        MethodDictionary inspectorClass
        Object inspectorExtraAttributes
        OrderedCollection inspectorClass
        RunArray inspectorClass
        Set inspectorClass
        Text inspectorExtraAttributes
        'NameSpace class' inspectorClass
        'Smalltalk class' inspectorClass
    )
! !

!stx_libtool class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X Tools'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2009\nCopyright eXept Software AG 1998-2009'

    "Modified: / 08-11-2007 / 16:58:51 / cg"
! !

!stx_libtool class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libtool/stx_libtool.st,v 1.42 2010-04-23 12:12:45 stefan Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/libtool/stx_libtool.st,v 1.42 2010-04-23 12:12:45 stefan Exp $'
! !
